<?php

function render_object ($subject, $object, $info, $type) {
	
	global $locale, $settings, $aidlink;
	
	$pageurl = $type;
	if ($type == "article") {
		$pageurl .= "s";
	}
	
	
	$caturl = $pageurl;
	if ($type == "news") {
		$caturl .= "_cats";
	}
	
	$commentsparam = $pageurl;
	if ($type == "news") {
		$commentsparam = "readmore";
	} else if ($type == "article") {
		$commentsparam = "article_id";
	}
	
	
	echo '<div class="panel ';
	if (isset($info[$type.'_sticky']) && $info[$type.'_sticky'] == "1") { 
		echo 'panel-info';
	} else {
		echo 'panel-primary';	
	}
	echo'">';
	echo '<div class="panel-heading">';
	echo '<h3 class="panel-title">';
	
	if (isset($info[$type.'_sticky']) && $info[$type.'_sticky'] == "1") {
		echo "<i class='icon-pushpin'></i> ";
	}
	
	echo $subject.'</h3>';
	
	echo '</div>';
	echo '<div class="panel-body news-entry">';
	
	echo '<div class="news-meta">';
	echo "<span class='date'><i class='icon-calendar'></i> ".showdate("newsdate", $info[$type.'_date'])."</span>\n";
	if ($info['cat_id']) { echo "<span class='cat'><a href='".BASEDIR.$caturl.".php?cat_id=".$info['cat_id']."'><i class='icon-tag'></i> ".$info['cat_name']."</a></span>\n";
	} else { echo "<span class='cat'><a href='".BASEDIR.$caturl.".php?cat_id=0'><i class='icon-folder-open'></i> ".$locale['global_080']."</a></span>\n"; }
	echo "<span class='author'><i class='icon-user'></i> ".profile_link($info['user_id'], $info['user_name'], $info['user_status'])."</span>\n";
	
	if (iADMIN && checkrights("N")) {
    echo "<span class='edit'><a href='".ADMIN.$pageurl.".php".$aidlink."&amp;action=edit&amp;".$type."_id=".$info[$type.'_id']."'><i class='icon-edit'></i> ".$locale['global_076']."</a>\n";
    }

	echo '</div>';
	
	if (isset($info['cat_image'])) { echo '<div class="pull-left news-entry-image" style="margin-right: 15px;">'.$info['cat_image'].'</div>'; }
	
	echo $object;
	
	//print_r($info);
	
	if (!isset($_GET['readmore']) && isset($info['news_ext']) && $info['news_ext'] == "y") {
	echo "<div class='pull-right'>\n";
	echo "<a href='".BASEDIR."news.php?readmore=".$info['news_id']."' class='btn btn-default btn-sm'><i class='icon-expand'></i> ".$locale['global_072']."</a></div>\n";
	}
	
	echo '</div>';
	echo '<div class="panel-footer news-footer-meta">';
	
	//echo newsopts($info, " - ");
	
	if ($info[$type.'_allow_comments'] && $settings['comments_enabled'] == "1") {
    echo "<span class='comments'><a href='".BASEDIR.$pageurl.".php?".$commentsparam."=".$info[$type.'_id']."#comments'><i class='icon-comments'></i> ".$info[$type.'_comments'].($info[$type.'_comments'] == 1 ? $locale['global_073b'] : $locale['global_073'])."</a></span>\n"; }
    
    echo "<span class='reads'><i class='icon-eye-open'></i> ".$info[$type.'_reads'].$locale['global_074']."</span>\n"; 
	
	echo "<span class='print pull-right' style='margin-right: 0;'><a href='".BASEDIR."print.php?type=".strtoupper(substr($type, 0, 1))."&amp;item_id=".$info[$type.'_id']."'><i class='icon-print'></i></a></span>\n";
	
	echo '</div></div>';
	
}




set_image("up", "up");
set_image("down", "down");
set_image("left", "left");
set_image("right", "right");
	
set_image("printer", "printer");
set_image("reply", "reply");
set_image("quote", "quote");
set_image("forum_edit", "forum_edit");
set_image("newthread", "newthread");
set_image("web", "web");
set_image("pm", "pm");

set_image("screenshot", "screenshot");
set_image("calendar", "calendar");
set_image("download", "download");
set_image("downloads", "downloads");
set_image("statistics", "statistics");

set_image("folder", "folder");
set_image("folderhot", "folderhot");
set_image("folderlock", "folderlock");
set_image("foldernew", "foldernew");
set_image("stickythread", "stickythread");

set_image("star", "star");
set_image("pollbar", THEME . "blank.php?n=pollbar");




function fix_theme_output($output) {
		
	$search = array(
		"<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>",
		"&raquo;",
		"iso-8859-1",
		"<li class='current-link'>",
		"<div class='collapse navbar-collapse navbar-ex1-collapse'><ul>"

	);
	$replace = array(
		'<!DOCTYPE html>',
		'/',
		'windows-1252',
		'<li class="current-link active">',
		'<div class="collapse navbar-collapse navbar-ex1-collapse"><ul class="nav navbar-nav">'
	);
	$output = str_replace($search, $replace, $output);
	

	$search = array(
		"@><img src='up' alt='(.*?)' title='(.*?)' style='border:0;vertical-align:middle' />@si",
		"@><img src='down' alt='(.*?)' title='(.*?)' style='border:0;vertical-align:middle' />@si",
		"@><img src='left' alt='(.*?)' title='(.*?)' style='border:0;vertical-align:middle' />@si",
		"@><img src='right' alt='(.*?)' title='(.*?)' style='border:0;vertical-align:middle' />@si",
		"@><img src='printer' alt='(.*?)' title='(.*?)' style='border:0;vertical-align:middle' />@si",
		"@><img src='reply' alt='(.*?)' style='border:0px' />@si",
		"@><img src='newthread' alt='(.*?)' style='border:0px;?' />@si",
		"@><img src='web' alt='(.*?)' style='border:0;vertical-align:middle' />@si",
		"@><img src='pm' alt='(.*?)' style='border:0;vertical-align:middle' />@si",
		"@><img src='quote' alt='(.*?)' style='border:0px;vertical-align:middle' />@si",
		"@><img src='forum_edit' alt='(.*?)' style='border:0px;vertical-align:middle' />@si",
		"@><img src='screenshot' alt='(.*?)' />@si",
		"@><img src='calendar' alt='(.*?)' />@si",
		"@><img src='download' alt='(.*?)' style='border:none;' title='(.*?)'  />@si",
		"@<img src='downloads' alt='(.*?)' />@si",
		"@><img src='statistics' alt='(.*?)' />@si",
		"@<img src='folder' alt='(.*?)' />@si",
		"@<img src='folderhot' alt='(.*?)' />@si",
		"@<img src='folderlock' alt='(.*?)' />@si",
		"@<img src='foldernew' alt='(.*?)' />@si",
		"@<img src='stickythread' alt='(.*?)' style='vertical-align:middle;' />@si",
		"@<img src='star' alt='(.*?)' style='vertical-align:middle; width:10px;height:10px;' />@si"
	);
	$replace = array(
		' title="$2"><i class="icon-chevron-up"></i>',
		' title="$2"><i class="icon-chevron-down"></i>',
		' title="$2"><i class="icon-chevron-left"></i>',
		' title="$2"><i class="icon-chevron-right"></i>',
		' title="$2"><i class="icon-print"></i>',
		' class="btn btn-default btn-xs">$1',
		' class="btn btn-default btn-xs">$1',
		' rel="nofollow" title="$1"><i class="icon-globe icon-large"></i>',
		' title="$1"> <i class="icon-envelope icon-large"></i>',
		' title="$1"><i class="icon-quote-left icon-large"></i>',
		' title="$1"><i class="icon-edit icon-large"></i>',
		' title="$1"><i class="icon-screenshot icon-2x"></i>',
		' title="$1"><i class="icon-calendar icon-2x"></i>',
		' title="$1"><i class="icon-download icon-3x"></i>',
		'<i class="icon-save icon-2x"></i>',
		' title="$1"><i class="icon-bar-chart icon-4x"></i>',
		'<i class="icon-folder-open icon-large" style="opacity: .5;"></i>',
		'<i class="icon-folder-open icon-large"></i>',
		'<i class="icon-lock icon-large"></i>',
		'<i class="icon-folder-open icon-large"></i>',
		'<i class="icon-pushpin icon-large"></i>',
		'<i class="icon-star" style="color: gold;" title="$1"></i>'
	);
	$output = preg_replace($search, $replace, $output);
	
	//libxml_use_internal_errors(true);
	$doc = new DOMDocument();
	$doc->loadHTML($output);
	
	foreach( $doc->getElementsByTagName('*') as $tag) {
        $tag->removeAttribute("width");
        $tag->removeAttribute("align");
        $tag->removeAttribute("valign");
        $tag->removeAttribute("cellpadding");
        $tag->removeAttribute("cellspacing");
    }
	
	foreach( $doc->getElementsByTagName('table') as $tag) {
        $tag->setAttribute('class', ($tag->hasAttribute('class') ? $tag->getAttribute('class') . ' ' : '') . 'table');
    }
	
	foreach(getElementsByClassName($doc, 'admin-message') as $tag) {
        $tag->setAttribute('class', ($tag->hasAttribute('class') ? $tag->getAttribute('class') . ' ' : '') . 'alert alert-warning');
	}
	
	foreach(getElementsByClassName($doc, 'button') as $tag) {
        $tag->setAttribute('class', ($tag->hasAttribute('class') ? $tag->getAttribute('class') . ' ' : '') . 'btn btn-default');
	}
	
	$output = $doc->saveHTML();

	
	
	return $output;
}

function getElementsByClassName(DOMDocument $DOMDocument, $ClassName)
{
    $Elements = $DOMDocument -> getElementsByTagName("*");
    $Matched = array();
 
    foreach($Elements as $node)
    {
        if( ! $node -> hasAttributes())
            continue;
 
        $classAttribute = $node -> attributes -> getNamedItem('class');
 
        if( ! $classAttribute)
            continue;
 
        $classes = explode(' ', $classAttribute -> nodeValue);
 
        if(in_array($ClassName, $classes))
            $Matched[] = $node;
    }
 
    return $Matched;
}

?>